%global gtk3_version 3.19.8
%global glib_version 2.53.2
%global gobject_introspection_version 1.41.0
%global gsettings_desktop_schemas_version 3.21.4
%global json_glib_version 0.12.0
%global libinput_version 1.4
%global pipewire_version 0.2.2

Name:           mutter328
Version:        3.28.3
Release:        4%{?dist}
Summary:        Window and compositing manager based on Clutter
License:        GPLv2+

URL:            http://www.gnome.org
Source0:        http://download.gnome.org/sources/mutter/3.28/mutter-%{version}.tar.xz

Patch0:         00-startup-notification.patch

# Upload HW cursor on demand, avoiding stuttering on hybrid GPU laptops
Patch1:         01-hw-cursor-on-demand-gnome-3-28.patch

# Check hw support for calculated view transform
Patch2:         02-renderer-native-Check-calculated-transform-when-crea.patch

# PipeWire 0.2.2+ support
Patch3:         03-mutter-search-for-libpipewire-0_2.patch
Patch4:         04-mutter-pipewire-0_2-API.patch

BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  desktop-file-utils
BuildRequires:  gnome-common
BuildRequires:  gtk-doc
BuildRequires:  libtool
BuildRequires:  zenity

BuildRequires:  gettext-devel
BuildRequires:  pam-devel

BuildRequires:  pkgconfig(cairo) >= 1.10.0
BuildRequires:  pkgconfig(egl)
BuildRequires:  pkgconfig(gbm)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(glesv2)
BuildRequires:  pkgconfig(gio-unix-2.0) >= %{glib_version}
BuildRequires:  pkgconfig(glib-2.0) >= %{glib_version}
BuildRequires:  pkgconfig(gnome-desktop-3.0)
BuildRequires:  pkgconfig(gobject-introspection-1.0) >= %{gobject_introspection_version}
BuildRequires:  pkgconfig(gsettings-desktop-schemas) >= %{gsettings_desktop_schemas_version}
BuildRequires:  pkgconfig(gtk+-3.0) >= %{gtk3_version}
BuildRequires:  pkgconfig(gudev-1.0)
BuildRequires:  pkgconfig(json-glib-1.0) >= %{json_glib_version}
BuildRequires:  pkgconfig(libcanberra)
BuildRequires:  pkgconfig(libdrm)
BuildRequires:  pkgconfig(libinput)
BuildRequires:  pkgconfig(libpipewire-0.2) >= %{pipewire_version}
BuildRequires:  pkgconfig(libstartup-notification-1.0)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(libwacom)
BuildRequires:  pkgconfig(pango) >= 1.2.0
BuildRequires:  pkgconfig(pangoft2)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(systemd)
BuildRequires:  pkgconfig(upower-glib) >= 0.99.0
BuildRequires:  pkgconfig(wayland-server)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xcb)
BuildRequires:  pkgconfig(xcomposite) >= 0.2
BuildRequires:  pkgconfig(xcursor)
BuildRequires:  pkgconfig(xdamage)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xfixes)
BuildRequires:  pkgconfig(xi) >= 1.6.0
BuildRequires:  pkgconfig(xkbcommon) >= 0.4.3
BuildRequires:  pkgconfig(xkbcommon-x11)
BuildRequires:  pkgconfig(xkbfile)
BuildRequires:  pkgconfig(xkeyboard-config)
BuildRequires:  pkgconfig(xrandr)
BuildRequires:  pkgconfig(xrender)
BuildRequires:  pkgconfig(xtst)

Obsoletes:      mutter-wayland < 3.13.0
Obsoletes:      mutter-wayland-devel < 3.13.0

# Make sure yum updates gnome-shell as well; otherwise we might end up with
# broken gnome-shell installations due to mutter ABI changes.
Conflicts:      gnome-shell < 3.21.1

# Conflict with the main mutter package
Conflicts:      mutter >= 3.29.4

Requires:       control-center-filesystem
Requires:       dbus-x11
Requires:       gsettings-desktop-schemas%{?_isa} >= %{gsettings_desktop_schemas_version}
Requires:       gtk3%{?_isa} >= %{gtk3_version}
Requires:       pipewire%{?_isa} >= %{pipewire_version}
Requires:       startup-notification
Requires:       zenity

Requires:       json-glib%{?_isa} >= %{json_glib_version}
Requires:       libinput%{?_isa} >= %{libinput_version}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description
Mutter is a window and compositing manager that displays and manages
your desktop via OpenGL. Mutter combines a sophisticated display engine
using the Clutter toolkit with solid window-management logic inherited
from the Metacity window manager.

While Mutter can be used stand-alone, it is primarily intended to be
used as the display core of a larger system such as GNOME Shell. For
this reason, Mutter is very extensible via plugins, which are used both
to add fancy visual effects and to rework the window management
behaviors to meet the needs of the environment.


%package        libs
Summary:        Shared libraries for %{name}

Requires:       mutter%{?_isa} >= 3.29.4
Conflicts:      mutter%{?_isa} < 3.29.4

%description    libs
Shared libraries for Mutter.


%package        devel
Summary:        Development package for %{name}

Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
Conflicts:      mutter-devel%{?_isa}

%description    devel
Header files and libraries for developing Mutter plugins. Also includes
utilities for testing Metacity/Mutter themes.


%package        tests
Summary:        Tests for the %{name} package

Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
Conflicts:      mutter-tests%{?_isa}

%description tests
The %{name}-tests package contains tests that can be used to verify
the functionality of the installed %{name} package.


%prep
%autosetup -n mutter-%{version} -p1


%build
autoreconf -f -i

%configure \
    --disable-static \
    --enable-compile-warnings=maximum \
    --enable-remote-desktop \
    --enable-installed-tests \
    --with-libwacom

%make_build


%install
%make_install

%find_lang mutter

# remove libtool archives
find %{buildroot} -name "*.la" -print -delete


%check
desktop-file-validate \
    %{buildroot}/%{_datadir}/applications/mutter.desktop


%ldconfig_scriptlets libs


%files -f mutter.lang
%{_bindir}/mutter

%{_libexecdir}/mutter-restart-helper

%{_libdir}/mutter/plugins/

%{_datadir}/applications/*.desktop
%{_datadir}/GConf/gsettings/mutter-schemas.convert
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.wayland.gschema.xml
%{_datadir}/gnome-control-center/keybindings/50-mutter-*.xml

%{_mandir}/man1/mutter.1*

%files libs
%license COPYING
%doc NEWS

%{_libdir}/lib*.so.*
%{_libdir}/mutter/

%exclude %{_libdir}/mutter/plugins

%files devel
%{_includedir}/*
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*

%files tests
%{_libexecdir}/installed-tests/mutter
%{_libexecdir}/installed-tests/mutter-clutter
%{_libexecdir}/installed-tests/mutter-cogl

%{_datadir}/installed-tests/mutter
%{_datadir}/installed-tests/mutter-clutter
%{_datadir}/installed-tests/mutter-cogl
%{_datadir}/mutter/tests


%changelog
* Sun Sep 09 2018 Fabio Valentini <decathorpe@gmail.com> - 3.28.3-4
- Initial compat package of mutter 3.28.

